'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _decorateComponentWithProps = require('decorate-component-with-props');

var _decorateComponentWithProps2 = _interopRequireDefault(_decorateComponentWithProps);

var _createStore = require('./utils/createStore');

var _createStore2 = _interopRequireDefault(_createStore);

var _Sidebar = require('./components/Sidebar');

var _Sidebar2 = _interopRequireDefault(_Sidebar);

var _DefaultBlockTypeSelect = require('./components/DefaultBlockTypeSelect');

var _DefaultBlockTypeSelect2 = _interopRequireDefault(_DefaultBlockTypeSelect);

var _buttonStyles = {
  "buttonWrapper": "draftJsSidebarPlugin__buttonWrapper__1Dmqh",
  "button": "draftJsSidebarPlugin__button__qi1gf",
  "active": "draftJsSidebarPlugin__active__3qcpF",
  "separator": "draftJsSidebarPlugin__separator__3M3L7"
};

var _buttonStyles2 = _interopRequireDefault(_buttonStyles);

var _blockTypeSelectStyles = {
  "blockType": "draftJsSidebarPlugin__blockType__27Jwn",
  "spacer": "draftJsSidebarPlugin__spacer__2Os2z",
  "popup": "draftJsSidebarPlugin__popup__GHzbY"
};

var _blockTypeSelectStyles2 = _interopRequireDefault(_blockTypeSelectStyles);

var _sidebarStyles = {
  "wrapper": "draftJsSidebarPlugin__wrapper__3on36"
};

var _sidebarStyles2 = _interopRequireDefault(_sidebarStyles);

var _modalStyles = {
  "modalWrapper": "draftJsSidebarPlugin__modalWrapper__EaX74",
  "modalInput": "draftJsSidebarPlugin__modalInput__1sp75",
  "modalButton": "draftJsSidebarPlugin__modalButton__ffoIL",
  "modalButtonWrapper": "draftJsSidebarPlugin__modalButtonWrapper__27s-M"
};

var _modalStyles2 = _interopRequireDefault(_modalStyles);

var _gifPickerStyles = {
  "wrapper": "draftJsSidebarPlugin__wrapper__ih9FN",
  "picker": "draftJsSidebarPlugin__picker__iDUNn",
  "gif": "draftJsSidebarPlugin__gif__3NqJR",
  "input": "draftJsSidebarPlugin__input__33l4h",
  "closeWrapper": "draftJsSidebarPlugin__closeWrapper__Fz",
  "close": "draftJsSidebarPlugin__close__3IRgw"
};

var _gifPickerStyles2 = _interopRequireDefault(_gifPickerStyles);

var _emojiPickerStyles = {
  "wrapper": "draftJsSidebarPlugin__wrapper__2Hef_",
  "picker": "draftJsSidebarPlugin__picker__2FUMw",
  "emoji": "draftJsSidebarPlugin__emoji__2ci96",
  "tabWrapper": "draftJsSidebarPlugin__tabWrapper__v0rd2",
  "tab": "draftJsSidebarPlugin__tab__1djJ6",
  "closeWrapper": "draftJsSidebarPlugin__closeWrapper__15umu",
  "close": "draftJsSidebarPlugin__closeWrapper__15umu"
};

var _emojiPickerStyles2 = _interopRequireDefault(_emojiPickerStyles);

var _getModalByType = require('./components/getModalByType');

var _getModalByType2 = _interopRequireDefault(_getModalByType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var defaultTheme = { buttonStyles: _buttonStyles2.default, blockTypeSelectStyles: _blockTypeSelectStyles2.default, sidebarStyles: _sidebarStyles2.default, modalStyles: _modalStyles2.default, gifPickerStyles: _gifPickerStyles2.default, emojiPickerStyles: _emojiPickerStyles2.default };

  var store = (0, _createStore2.default)({
    isVisible: false
  });

  var _config$theme = config.theme,
      theme = _config$theme === undefined ? defaultTheme : _config$theme,
      _config$structure = config.structure,
      structure = _config$structure === undefined ? [_DefaultBlockTypeSelect2.default] : _config$structure;


  var sidebarProps = {
    store: store,
    structure: structure,
    getModalByType: _getModalByType2.default,
    theme: theme
  };

  return {
    initialize: function initialize(_ref) {
      var setEditorState = _ref.setEditorState,
          getEditorState = _ref.getEditorState,
          getEditorRef = _ref.getEditorRef;

      store.updateItem('getEditorState', getEditorState);
      store.updateItem('setEditorState', setEditorState);
      store.updateItem('getEditorRef', getEditorRef);
    },
    // Re-Render the sidebar on every change
    onChange: function onChange(editorState) {
      store.updateItem('editorState', editorState);
      return editorState;
    },
    Sidebar: (0, _decorateComponentWithProps2.default)(_Sidebar2.default, sidebarProps)
  };
}; /*
    * Copyright (c) 2016, Globo.com (https://github.com/globocom)
    * Copyright (c) 2016, vace.nz (https://github.com/vacenz)
    * Copyright (c) 2016, Nik Graf (https://www.draft-js-plugins.com)
    *
    * License: MIT
    */
